package req

import "encoding/json"

func (p *SyncthingHttpClient) Events() ([]event, error) {
	resp, err := p.get("rest/events")
	if err != nil {
		return nil, err
	}
	var eventList []event
	if err = json.Unmarshal(resp, &eventList); err != nil {
		return nil, err
	}
	return eventList, err
}

type event struct {
	Id        int64  `json:"id"`
	GlobalID  int64  `json:"globalID"`
	EventType string `json:"type"`
	Time      string `json:"time"`
	Data      data   `json:"data"`
}

type data struct {
	Completion float64 `json:"completion"`
	Device     string  `json:"device"`
	Folder     string  `json:"folder"`
}
